commit:     7bf83654350af110e595e6a392981dcedfc7a216
Author:     Brahmajit Das <brahmajit.xyz <AT> gmail <DOT> com>
AuthorDate: Sun Sep 10 12:55:45 2023 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Mon Sep 11 00:53:40 2023 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=7bf83654

dev-lua/luv: add 1.45.0.0

Needed for new neovim.

Bug: https://bugs.gentoo.org/913912
Signed-off-by: Brahmajit Das <brahmajit.xyz <AT> gmail.com>
Closes: https://github.com/gentoo/gentoo/pull/32709
Signed-off-by: Sam James <sam <AT> gentoo.org>

 dev-lua/luv/Manifest            |  1 +
 dev-lua/luv/luv-1.45.0.0.ebuild | 86 +++++++++++++++++++++++++++++++++++++++++
 2 files changed, 87 insertions(+)

diff --git a/dev-lua/luv/Manifest b/dev-lua/luv/Manifest
index 1c197e845855..05e4070c4e16 100644
--- a/dev-lua/luv/Manifest
+++ b/dev-lua/luv/Manifest
@@ -1,2 +1,3 @@
 DIST luv-1.44.2.0.tar.gz 124180 BLAKE2B 
0a46ffccd67bf04fb60c7aa3685fef328da1323437640a04b36748680aaf4074300097c53206915d8a1133defc61a359cd88062f1661899dfa8c394c183f0d0d
 SHA512 
0744590de941ec67e23e04811ed28de5e5ed8b6dd0d45e52e8e0efe0551d007f28cdada8e0d69e0d59bd37d4026102271a8ef977b12cfac1e84f6c8b57e6adce
+DIST luv-1.45.0.0.tar.gz 130334 BLAKE2B 
f22f6705204db567de7943707b499897fbd51cf33c6bc571612e0682f3b6022d6dd56606df0ff850e72bde398f00c4db00c026f1b8de5182458b39095716cbd7
 SHA512 
50460573377bc9386a90aa75f7d4938571b04f74ca6f63e32fa2b2f8951e799465abb78b4270f22be511c4d328ce582c38ec3e3da1061310fcfee630b647854d
 DIST luv-lua-compat-0.10.tar.gz 53695 BLAKE2B 
e570aedb23b8ed7ca38c4316ffab25b93a0f9f6f0fae79af563ca8a81dd6453ac273e1f9e70674c484a2dec68749e7d53a1c1736a72616c210b8e38a31b3f191
 SHA512 
f7f39085f4f6b16095f41e635b4c5477b3dab5e42b5b65a9d522941a3807ea521d4a27a77293a3c9d0ecea78a1f6c2a2497394b2d220f4d7d65e23510563d46d

diff --git a/dev-lua/luv/luv-1.45.0.0.ebuild b/dev-lua/luv/luv-1.45.0.0.ebuild
new file mode 100644
index 000000000000..8d24ac375d6d
--- /dev/null
+++ b/dev-lua/luv/luv-1.45.0.0.ebuild
@@ -0,0 +1,86 @@
+# Copyright 2019-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+LUA_COMPAT=( lua5-{1..4} luajit )
+
+inherit cmake flag-o-matic lua-single unpacker
+
+# e.g. MY_PV = a.b.c-d
+MY_PV="$(ver_rs 3 -)"
+MY_P="${PN}-${MY_PV}"
+
+DESCRIPTION="Bare libuv bindings for lua"
+HOMEPAGE="https://github.com/luvit/luv";
+
+LUA_COMPAT_PV="0.10"
+SRC_URI="
+       https://github.com/luvit/${PN}/archive/${MY_PV}.tar.gz -> ${P}.tar.gz
+       
https://github.com/keplerproject/lua-compat-5.3/archive/v${LUA_COMPAT_PV}.tar.gz
 -> ${PN}-lua-compat-${LUA_COMPAT_PV}.tar.gz
+"
+
+LICENSE="Apache-2.0 MIT"
+SLOT="0"
+KEYWORDS="~amd64 ~arm ~arm64 ~ppc64 ~riscv ~x86 ~x64-macos"
+IUSE="test"
+RESTRICT="!test? ( test )"
+
+REQUIRED_USE="${LUA_REQUIRED_USE}"
+
+BDEPEND="virtual/pkgconfig"
+DEPEND="${LUA_DEPS}
+       >=dev-libs/libuv-$(ver_cut 1-2):="
+RDEPEND="${DEPEND}"
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-1.43.0.0-cmake_lua_version.patch
+)
+
+S="${WORKDIR}/${MY_P}"
+
+src_prepare() {
+       # Fix libdir
+       # Match '/lib/' and '/lib"' without capturing / or ", replacing with 
libdir
+       sed -i -r "s/\/lib(\"|\/)/\/$(get_libdir)\1/g" CMakeLists.txt || die 
"Failed to sed CMakeLists.txt"
+       cmake_src_prepare
+}
+
+# This could in theory be multi-impl (and we have an ebuild in git history,
+# 1.32.0.0-r101, which implements it) - the only revdep currently in the tree,
+# app-editors/neovim, actually links against luv instead of trying to load it
+# as a module. We could probably implement some sort of a hack for this
+# - but given how messy it would be, don't bother unless someone actually 
requests
+# luv multi-impl support.
+src_configure() {
+       lua_compat_dir="${WORKDIR}/lua-compat-5.3-${LUA_COMPAT_PV}"
+
+       local mycmakeargs=(
+               -DBUILD_MODULE=OFF
+               -DLUA_BUILD_TYPE=System
+               -DLUA_COMPAT53_DIR="${lua_compat_dir}"
+               -DWITH_SHARED_LIBUV=ON
+       )
+       if [[ ${ELUA} == luajit ]]; then
+               mycmakeargs+=(
+                       -DWITH_LUA_ENGINE=LuaJIT
+               )
+       else
+               mycmakeargs+=(
+                       -DWITH_LUA_ENGINE=Lua
+                       -DLUA_VERSION=$(ver_cut 1-2 $(lua_get_version))
+               )
+       fi
+
+       if [[ ${CHOST} == *-darwin* ]] ; then
+               append-ldflags "-undefined dynamic_lookup"
+       fi
+
+       cmake_src_configure
+}
+
+src_test() {
+       # We need to copy the library back so that the tests see it
+       ln -s "${BUILD_DIR}/libluv.so" "./luv.so" || die "Failed to symlink 
library for tests"
+       ${ELUA} "tests/run.lua" || die "Tests failed"
+}

Reply via email to